import java.util.Scanner;


class CScore 
{
	
	CScore()
	{
		m_fMath = 0.f;
		m_fKor = 0.f;
		m_fEng = 0.f;
		m_fSum = 0.f;
		m_fAvg = 0.f;
	}
	
	CScore(float fKor, float fEng, float fMath) 
	{
		SetScore(fKor, fEng, fMath);
	}
	
	
	
	float m_fMath;
	float m_fKor;
	float m_fEng;
	float m_fAvg;
	float m_fSum;
	
	
	private void DataUpdate() 
	{
		m_fSum = m_fMath + m_fKor + m_fEng;
		m_fAvg = m_fSum / 3.f;
	}
	
	// Set 
	public void SetKor(float fKor) {m_fKor = fKor; DataUpdate();}
	public void SetEng(float fEng) {m_fEng = fEng; DataUpdate();}
	public void SetMath(float fMath) {m_fMath = fMath; DataUpdate();}
	public void SetScore(float fKor, float fEng, float fMath) 
	{ 
		SetKor(fKor); SetMath(fMath); SetEng(fEng); 
		DataUpdate();
	}
	
	
	
	// Get
	public float GetKor() {return m_fKor;}
	public float GetMath() {return m_fKor;}
	public float GetEng() {return m_fEng;}
	public float GetSum() {return m_fSum;}
	public float GetAvg() {return m_fAvg;}
	
	
	public void OutputInfo() 
	{
		System.out.printf(" : %.1f  : %.1f  : %.1f\n : %.1f  : %.1f", m_fKor, m_fMath, m_fEng, 
				m_fSum, m_fAvg);
	}
	
	
	
}

class CHuman
{
	CHuman() {}
	CHuman(String strName) { SetName(strName);}
	
	String m_strName;
	
	public void SetName(String strName) {m_strName = strName;}
	public String GetName() {return m_strName;}
	
	public void OutputInfo() { System.out.printf("̸ : %s", m_strName);}
}


class CStudent extends CHuman
{
	
	CStudent() {m_Score = new CScore();  m_iNum = 0;}
	
	CStudent(String strName, float fKor, float fEng, float fMath, int iNum)
	{
		SetName(strName);
		m_Score = new CScore(fKor, fEng, fMath);
		SetNum(iNum);
	}
	
	

  	CScore m_Score;
  	int   m_iNum;
  	
  	public void SetNum(int iNum) {m_iNum = iNum;}
  	public void SetInfo(String strName, float fKor, float fEng, float fMath, int iNum)
	{
		SetName(strName);  m_Score.SetScore(fKor, fEng, fMath); SetNum(iNum);
	}
  	
  	public int GetNum() {return m_iNum;}
  
  	// Score Լ 
  	// Set 
 	public void SetKor(float fKor) {m_Score.SetKor(fKor);}
 	public void SetEng(float fEng) {m_Score.SetEng(fEng);}
 	public void SetMath(float fMath) {m_Score.SetMath(fMath);}
 	public void SetScore(float fKor, float fEng, float fMath) 
 	{ 
 		m_Score.SetScore(fKor, fEng, fMath);
 	}
 	
 	
 	
 	// Get
 	public float GetKor() {return m_Score.GetKor();}
 	public float GetMath() {return m_Score.GetMath();}
 	public float GetEng() {return m_Score.GetEng();}
 	public float GetSum() {return m_Score.GetSum();}
 	public float GetAvg() {return m_Score.GetAvg();}
 	
 	
 	public void OutputInfo() 
 	{
 		System.out.printf("\n");
 		super.OutputInfo(); // ̸
 		System.out.printf(" / ȣ : %d\n", m_iNum); // ȣ
 		m_Score.OutputInfo(); //  
 		System.out.printf("\n\n");
 	}

 
}

//  Լ




public class StudentManage 
{
	
	 static Scanner sc = new Scanner(System.in);
     static int m_iSize = 0;
     static int m_iCapacity = 10;
     static CStudent[] m_StudentArr = new CStudent[m_iCapacity]; 
     
     public static void resize()
     {
    	 if(m_iCapacity == m_iSize)
    	 {
    		 m_iCapacity *= 2;
    		 CStudent[] studentArr = new CStudent[m_iCapacity];
    		 
    		 for(int i = 0; i < m_iSize; ++i)
    		 {
    			 studentArr[i] = m_StudentArr[i];
    		 }
    		 
    		 m_StudentArr = studentArr;
    	 }
     }
     
     
    public static void AddStudent()
    {
    	resize();
    	
    	String strName;
    	float fKor = 0.f;
    	float fEng = 0.f;
    	float fMath = 0.f;
    	int iNum = 0;
    	

    	System.out.printf("̸ Էּ : ");
    	strName = sc.next();
    	System.out.printf("ȣ : ");
    	iNum = sc.nextInt();
    	System.out.printf("  : ");
    	fKor = sc.nextFloat();
    	System.out.printf("  : ");
    	fEng = sc.nextFloat();
    	System.out.printf("  : ");
    	fMath = sc.nextFloat();
    	
    	CStudent tStudent = new CStudent(strName, fKor, fEng, fMath, iNum);
    	m_StudentArr[m_iSize] = tStudent;
    	++m_iSize;
    }
     
	public static int OutputMenu()
	{
	      System.out.println("1. л ߰");
	      System.out.println("2. л ");
	      System.out.println("3. л ˻");
	      System.out.println("4. л ");
	      System.out.println("5. ");
	      System.out.printf(">>");
	      
	      int iInput = 0;
	      iInput = sc.nextInt();
	      
	     if(iInput < 0 || iInput > 5)
	    	 iInput = 0;
	      
	      return iInput;
	}
	
	public static int OutputOption()
	{
		System.out.println("1. ȣ л ã");
		System.out.println("2. ̸ л ã");
		int iInput = sc.nextInt();
		if(iInput <= 0 || iInput > 2)
			iInput = 0;
		
		return iInput;
	}
	
	public static void StudentDelete()
	{
		// ȣ or ̸ Է¹޴´.
		
		int iStudentIdx = -1;
		
		switch(OutputOption())
		{
			case 1: // ȣ
			{
				int iNum = 0;
				System.out.printf("ȣ Էּ : ");
				iNum = sc.nextInt();
				iStudentIdx = FindStudent(iNum);
			}
			break;
			
			case 2: // ̸
			{
				String strName;
				System.out.printf("̸ Էּ : ");
				strName = sc.next();
				iStudentIdx = FindStudent(strName);
			}
			
			break;
			
			case 0:
				System.out.println("Է ߸Ǿϴ.");
				return;
				
		}
		
		if(iStudentIdx == -1)
		{
			// ش  л ã .
			System.out.println("л ã  ϴ.");
		}
		else
		{
			//  Ѵ.
			for(int i = iStudentIdx; i < m_iSize - 1; ++i)
			{
				m_StudentArr[i] = m_StudentArr[i+1];
			}
			--m_iSize;
			
			System.out.println("л  Ϸ");
		}
	}
	
	public static int FindStudent(String strName)
	{
		for(int i = 0; i < m_iSize; ++i)
		{
			if(m_StudentArr[i].GetName().equals(strName))
			{
				// ==  ؼ ڿ   , equalsԼ ̿ؾ Ѵ.
				return i;
			}
				
		}	
		
		return -1;
	}
	
	public static int FindStudent(int iNum)
	{
		for(int i = 0; i < m_iSize; ++i)
		{
			if(m_StudentArr[i].GetNum() == iNum)
			{
				return i;
			}
				
		}	
		
		return -1;
	}

	
	public static void StudentSearch()
	{
		int iStudentIdx = -1;
		
		switch(OutputOption())
		{
			case 1: // ȣ
			{
				int iNum = 0;
				System.out.printf("ȣ Էּ : ");
				iNum = sc.nextInt();
				iStudentIdx = FindStudent(iNum);
			}
			break;
			
			case 2: // ̸
			{
				String strName;
				System.out.printf("̸ Էּ : ");
				strName = sc.next();
				iStudentIdx = FindStudent(strName);
			}
			
			break;
			
			case 0:
				System.out.println("Է ߸Ǿϴ.");
				return;
				
		}
		
		if(iStudentIdx == -1)
		{
			// ش  л ã .
			System.out.println("л ã  ϴ.");
		}
		else
		{
			// л  ش.
			m_StudentArr[iStudentIdx].OutputInfo();
		}
	}
	
	public static void StudentOutput()
	{
		//  л ش.
		
		for(int i = 0; i < m_iSize; ++i)
		{
			m_StudentArr[i].OutputInfo();
		}
		
		System.out.printf("\n ================ л %d ================ \n", m_iSize);
	}
	
	     
	

	public static void main(String[] args) 
	{
		int iInput = 0;
	      while(iInput != 5)
	      {
	    	 iInput = OutputMenu();
	    	 
	    	 switch(iInput)
	    	 {
	    	 case 1: // ߰
	    		 AddStudent();
	    		 break;
	    		 
	    	 case 2: //  
	    		 StudentDelete();
	    		 break;
	    		 
	    	 case 3: // ˻ 
	    		 StudentSearch();
	    		 break;
	    		 
	    	 case 4: //  
	    		 StudentOutput();
	    		 break;
	    		 
	    		 
	    	 }
	    	 
	    	 System.out.printf("\n");
	    	 
	      }
	      
	      sc.close();
	  
	}
	      
	      
	  
	  

}
